//
//  PrinterManager.h
//  PrinterExample
//
//  Created by King on 12/12/2017.
//  Copyright © 2017 Printer. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "Printer.h"
#import "WIFIFactory.h"
#import "Header.h"
#import "Cmd.h"
#import "SafeMutableArray.h"
#import "DeviceInfo.h";
#import "PrinterInterface.h"
#import "EnumTypeDef.h"




@protocol SelectDelegate <NSObject>
-(void)selectDeviceInfo:(DeviceInfo *)device;
-(void)selectPrinterInterface:(PrinterInterface *)printerpi;
@end




@interface PrinterManager : NSObject

@property (strong, nonatomic) Printer *CurrentPrinter;
//@property(nonatomic,strong)    PrinterInterface *printerInterface;
@property(nonatomic)  PrinterCmdType CurrentPrinterCmdType;//当前的指令类型
@property(nonatomic)  PrinterPortType CurrentPrinterPortType;//当前的端口类型
@property(nonatomic) SafeMutableArray *PrinterList;

+ (PrinterManager *)sharedInstance;
-(void)DoConnectwifi:(NSString *)Address Port:(NSInteger)Port;
-(void)DoConnectBle:(NSString *)Address;
- (void)AddConnectObserver:(id)observer selector:(SEL)aSelector;
-(Cmd *)CreateCmdClass:(PrinterCmdType)PrinterCmdType;
-(Printer *)CreatePrinterClass:(PrinterCmdType)PrinterCmdType;
-(void) AutoStartConnectBleNoScan:(NSString *) uuid;
-(NSData *) GetHeaderCmd:(Cmd *)cmd cmdtype:(PrinterCmdType)cmdtype;


@end
