//
//  ViewController.m
//  PrinterExample
//
//  Created by King on 08/12/2017.
//  Copyright © 2017 Printer. All rights reserved.
//



#import "ImageViewController.h"
#import "BitmapSetting.h"
#import "Cmd.h"
#import "PrinterManager.h"
#import <AssetsLibrary/AssetsLibrary.h>


//#import "ALAssetsLibrary+CustomPhotoAlbum.h"
@interface ImageViewController ()

@end



@implementation ImageViewController{
    ALAssetsLibrary* assetslibrary;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    assetslibrary = [[ALAssetsLibrary alloc] init];
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

-(void)printimageSync{
    PrinterManager *_printerManager = PrinterManager.sharedInstance;

    for (PrinterInterface *pi in _printerManager.PrinterList) {//多台打印机同时打印(Multiple printers print at the same time)
        Cmd *cmd =  [_printerManager CreateCmdClass:pi.printerCmdtype];
        if (cmd == NULL)
            return;
        [cmd Clear];
        cmd.encodingType =Encoding_UTF8;
        NSData *headercmd = [_printerManager GetHeaderCmd:cmd cmdtype:pi.printerCmdtype];
        [cmd Append:headercmd];
        
        
        Printer *currentprinter = _printerManager.CurrentPrinter;
        BitmapSetting *bitmapSetting  = currentprinter.BitmapSetts;
        switch (pi.printerCmdtype) {
                
            case PrinterCmdESC:
                bitmapSetting.Alignmode = Align_Center;
                bitmapSetting.limitWidth = 48*8;//ESC
                break;
            case PrinterCmdTSC:
            case PrinterCmdCPCL:
                bitmapSetting.pos_X = 20;
                bitmapSetting.pos_Y = 40;
                bitmapSetting.limitWidth = 60*8;
                break;
            case PrinterCmdPIN:
                bitmapSetting.limitWidth = self.imageView.image.size.width;
                break;
            default:
                break;
        }
        
        
        
        NSData *data= [cmd GetBitMapCmd:bitmapSetting image:self.imageView.image];
        [cmd Append:data];
    
        [cmd Append:[cmd GetPrintEndCmd]];
        if ([pi IsOpen]){
            [pi WriteAsync:[cmd GetCmd]];
        }
    }

    


}

- (IBAction)btnImagePrint:(id)sender {
    
    [self printimageSync];
    return;
    
    PrinterManager *_printerManager = PrinterManager.sharedInstance;
    
    Cmd *cmd = [_printerManager CreateCmdClass:_printerManager.CurrentPrinterCmdType];
    [cmd Clear];
    cmd.encodingType =Encoding_UTF8;
    NSData *headercmd = [_printerManager GetHeaderCmd:cmd cmdtype:_printerManager.CurrentPrinterCmdType];
    [cmd Append:headercmd];

    
    Printer *currentprinter = _printerManager.CurrentPrinter;
    BitmapSetting *bitmapSetting  = currentprinter.BitmapSetts;
    switch (_printerManager.CurrentPrinterCmdType) {
            
        case PrinterCmdESC:
            bitmapSetting.Alignmode = Align_Center;
            bitmapSetting.limitWidth = 48*8;//ESC
            break;
        case PrinterCmdTSC:
        case PrinterCmdCPCL:
            bitmapSetting.pos_X = 20;
            bitmapSetting.pos_Y = 40;
            bitmapSetting.limitWidth = 60*8;
            break;
        case PrinterCmdPIN:
            bitmapSetting.limitWidth = self.imageView.image.size.width;
            break;
        default:
            break;
    }

    
    
    NSData *data= [cmd GetBitMapCmd:bitmapSetting image:self.imageView.image];
    [cmd Append:data];
//    for (int i=0; i<2; i++) {
//       [cmd Append:[cmd GetLFCRCmd]];
//    }
    [cmd Append:[cmd GetPrintEndCmd]];
    if ([_printerManager.CurrentPrinter IsOpen]){
        [_printerManager.CurrentPrinter WriteAsync:[cmd GetCmd]];
    }
 
    data = nil;
    cmd=nil;
  
}

-(void)loadImage:(UIImage *)image{
    _imageView.image =image;
//    {
//        _imageView.contentMode = UIViewContentModeScaleAspectFit;
//        _imageView.image = [ BitmapConvert makeScaleImage:image maxWidth:48*8];
//    }
}



- (void) imagePickerController:(UIImagePickerController *)picker didFinishPickingMediaWithInfo:(NSDictionary *)info
{
    UIImage * image = [info valueForKey:UIImagePickerControllerOriginalImage];
    
    [self loadImage:image];
    
    NSURL *refURL = [info valueForKey:UIImagePickerControllerReferenceURL];
    
    _fileUrl =  [refURL absoluteString] ;
    
    ALAssetsLibraryAssetForURLResultBlock resultblock = ^(ALAsset *imageAsset)
    {
        ALAssetRepresentation *imageRep = [imageAsset defaultRepresentation];
        NSLog(@"[imageRep filename] : %@", [imageRep filename]);
        
        _fileTitle = [imageRep filename];
    };
    
    
    
    [assetslibrary assetForURL:refURL resultBlock:resultblock failureBlock:nil];
    
    
    [[self navigationController] dismissViewControllerAnimated:YES completion:nil];
}

- (IBAction)btnLoadImage:(id)sender {//
   UIImagePickerController* imagePicker = [[UIImagePickerController alloc] init];
    imagePicker.delegate = self;
    imagePicker.sourceType = UIImagePickerControllerSourceTypePhotoLibrary;
    // 编辑模式
    imagePicker.allowsEditing=false;

    [self presentViewController:imagePicker animated:YES completion:nil];

}

//测试图片
/*
-(NSData *) GetBitMapTestCmd{
    BitmapUtil * bitmaputil = [BitmapUtil new];
    NSInteger ilen=0;
   // -(Byte *) GetESCBitmapTimesPrintCmd:(UIImage*) image ResultLen:(NSInteger *)ResultLen {
    Byte *cmd = [bitmaputil Get24PinTimesBitmapPrintCmd:self.imageView.image ResultLen:&ilen];
    return [NSData dataWithBytesNoCopy:cmd length:ilen freeWhenDone:false];
//  Byte cmd[2]={0x12,0x54};
   // return [NSData dataWithBytes:cmd length:ilen];
    
//    NSString *s = @"标签指令";
//    return  [s dataUsingEncoding:NSUTF8StringEncoding];
}
 */

@end
