//
//  BlueToothFactory.h
//  RTPrinterSDK
//
//  Created by King on 28/11/2017.
//  Copyright © 2017 Rongta. All rights reserved.
//

#import "PrinterInterface.h"
#import "PIFactory.h"
#import "EnumTypeDef.h"
#import "BlueToothPI.h"

/*!
 创建蓝牙接口工厂类
 Factory class to create a BlueToothPI interface
 */
@interface BlueToothFactory : PIFactory

/*!
 根据蓝牙类型bluekind，创建对应的蓝牙接口BlueToothPI
 Through the parameter bluekind, create Bluetooth interface BlueToothPI
 interface
 @param bluekind 蓝牙类型 Bluetooth type
 @return BlueToothPI
 */
+(BlueToothPI *) Create:(BlueToothKind) bluekind;
@end
