//
//  PrinterManager.h
//  PrinterExample
//
//  Created by 朱正锋 on 12/12/2017.
//  Copyright © 2017 Printer. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "Printer.h"
#import "WIFIFactory.h"
#import "Header.h"
#import "Cmd.h"

typedef NS_ENUM(NSInteger, PrinterPortType) {
    PrinterPortWifi,
    PrinterPortBle,
    PrinterPortMFI
};

typedef NS_ENUM(NSInteger, PrinterCmdType) {
    PrinterCmdESC = 0,
    PrinterCmdTSC = 1,
    PrinterCmdCPCL = 2,
    PrinterCmdPIN =3
};


@interface PrinterManager : NSObject

@property (strong, nonatomic) Printer * CurrentPrinter;
@property(nonatomic,strong)    PrinterInterface *printerInterface;
@property(nonatomic)  PrinterCmdType CurrentPrinterCmdType;//当前的指令类型
@property(nonatomic)  PrinterPortType CurrentPrinterPortType;//当前的端口类型


+ (PrinterManager *)sharedInstance;
-(void)DoConnectwifi:(PrinterCmdType)PrinterCmdType Address:(NSString *)Address Port:(NSInteger)Port;
- (void)AddConnectObserver:(id)observer selector:(SEL)aSelector;
-(Cmd *)CreateCmdClass:(PrinterCmdType)PrinterCmdType;
-(NSMutableArray *)getBleNameList;
-(NSMutableArray *)getBleUuidList;
-(Printer *)CreatePrinterClass:(PrinterCmdType)PrinterCmdType;


@end
