//
//  ViewController.m
//  PrinterExample
//
//  Created by 朱正锋 on 08/12/2017.
//  Copyright © 2017 Printer. All rights reserved.
//



#import "ImageViewController.h"
#import "BitmapSetting.h"
#import "Cmd.h"
#import "PrinterManager.h"
#import "BitmapConvert.h"
#import <AssetsLibrary/AssetsLibrary.h>
//#import "ALAssetsLibrary+CustomPhotoAlbum.h"
@interface ImageViewController ()

@end



@implementation ImageViewController{
    ALAssetsLibrary* assetslibrary;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    assetslibrary = [[ALAssetsLibrary alloc] init];
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (IBAction)btnImagePrint:(id)sender {
    BitmapSetting *bitmapSetting = [BitmapSetting new];
    bitmapSetting.limitWidth = self.imageView.image.size.width+10;
    bitmapSetting.limitHeight = self.imageView.image.size.height;
    
    PrinterManager *_printerManager = PrinterManager.sharedInstance;
    
    Cmd *cmd = [_printerManager CreateCmdClass:_printerManager.CurrentPrinterCmdType];
    [cmd Clear];
    [cmd Append:cmd.GetHeaderCmd];
  
   #ifdef isTest  // DEBUG
    NSData *data= [self GetBitMapTestCmd];
   #else
    NSData *data= [cmd GetBitMapCmd:bitmapSetting image:self.imageView.image];
    #endif
    
    [cmd Append:data];
    [cmd Append:[cmd GetPrintEndCmd]];    
    if ([_printerManager.CurrentPrinter IsOpen]){
        [_printerManager.CurrentPrinter Write:[cmd GetCmd]];
    }
  
}

-(void)loadImage:(UIImage *)image{
    _imageView.image =image;
//    {
//        _imageView.contentMode = UIViewContentModeScaleAspectFit;
//        _imageView.image = [ BitmapConvert makeScaleImage:image maxWidth:48*8];
//    }
}



- (void) imagePickerController:(UIImagePickerController *)picker didFinishPickingMediaWithInfo:(NSDictionary *)info
{
    UIImage * image = [info valueForKey:UIImagePickerControllerOriginalImage];
    
    [self loadImage:image];
    
    NSURL *refURL = [info valueForKey:UIImagePickerControllerReferenceURL];
    
    _fileUrl =  [refURL absoluteString] ;
    
    ALAssetsLibraryAssetForURLResultBlock resultblock = ^(ALAsset *imageAsset)
    {
        ALAssetRepresentation *imageRep = [imageAsset defaultRepresentation];
        NSLog(@"[imageRep filename] : %@", [imageRep filename]);
        
        _fileTitle = [imageRep filename];
    };
    
    
    
    [assetslibrary assetForURL:refURL resultBlock:resultblock failureBlock:nil];
    
    
    [[self navigationController] dismissViewControllerAnimated:YES completion:nil];
}

- (IBAction)btnLoadImage:(id)sender {//
   UIImagePickerController* imagePicker = [[UIImagePickerController alloc] init];
    imagePicker.delegate = self;
    imagePicker.sourceType = UIImagePickerControllerSourceTypePhotoLibrary;
    // 编辑模式
    imagePicker.allowsEditing=false;

    [self presentViewController:imagePicker animated:YES completion:nil];

}


-(NSData *) GetBitMapTestCmd{
    Byte bytes[3000];

    //处理图片
    return [NSData dataWithBytes:bytes length:3000];
}

@end
