//
//  BleDevice.h
//  SportStone
//
//  Created by  Andrew Huang on 15/1/5.
//  Copyright (c) 2015年  Andrew Huang. All rights reserved.
//



#import <UIKit/UIKit.h>

#if TARGET_OS_IPHONE
#import <CoreBluetooth/CoreBluetooth.h>
#else
#import <IOBluetooth/IOBluetooth.h>
#endif



@class BleService;



@interface BleDevice : NSObject<CBPeripheralManagerDelegate>

@property (nonatomic, strong) NSString  * UUID; //对应外部设备uuid
@property (nonatomic, strong) NSString  * name; //设备逻辑名称，
@property (nonatomic, strong) NSString  * address; //设备蓝牙地址,通知其它方法间接取得，

@property float rssiThreshold; //用于防丢判断



@property NSInteger rssiLevel;                //实际信号强度，可以推算远/近和距离。
@property (nonatomic) CGFloat  distance;  //实际距离，米为单位
@property(nonatomic) NSInteger batteryValue;
@property(nonatomic) BOOL connected;


@property (nonatomic) BleService * bleService;

@property (nonatomic, retain) CBService * serialService; //串口服务

@property (strong,nonatomic) CBPeripheral *peripheral;

-(BOOL)isSameDevice:(CBPeripheral *)peripheral;
-(BOOL)isMyDevice:(CBPeripheral *)peripheral;

//-(void)didDiscoverCharacteristicsForService:(CBService *)service error:(NSError *)error;

-(BOOL)isNeedService:(CBService *)service;

-(BOOL)connect;
-(BOOL)disconnect;

-(BOOL)isConnected;

-(void)setBleDevice:(CBPeripheral *)peripheral;
-(void)setBleAdvertisementData:(NSDictionary *)AdvertisementData;



-(BOOL)isSerialDevice;
-(void)scanService;

-(BOOL)startRead;

-(BOOL)writeData:(CBCharacteristic *)writeChannel data:(unsigned char *)data len:(NSInteger)len;
-(BOOL)writeData:(CBCharacteristic *)writeChannel data:(NSData *)data;

-(NSInteger)readBuffer:(CBCharacteristic *)characteristic data:(unsigned char *)data len:(NSInteger)len;
-(NSData *)readBuffer:(CBCharacteristic *)characteristic;

-(void)sendDeviceConnected;
-(void)sendDeviceDisconnected;
-(void)sendDeviceDataNotify:(NSData *)data;
//-(void)sendDeviceOperateNotify:(NSInteger )cmd;

-(void)readRssi;

-(BOOL)sendData:(NSData *)data;
-(BOOL)sendData:(unsigned char  *)data len:(NSInteger)len;

-(NSString *)getAllName;
-(NSString *)getShortAddress;

@end
