//
//  Cmd.h
//  RTPrinterSDK
//
//  Created by yjm 22/11/2017.
//  Copyright © 2017 Rongta. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "TextSetting.h"
#import "CommonSetting.h"
#import <UIKit/UIKit.h>
#import "BitmapSetting.h"

//cmd 命令接口
#define BUFFER_MAX_LEN (1024*10)
@interface Cmd :NSObject

-(void)Append:(Byte*)bytes len:(NSInteger)len;
-(void)Append:(NSData *)data;
//把source的值赋值到dest，dest从index开始赋值，index每赋一个byte会加1
-(void)MoveData:(NSData *)source dest:(Byte *)dest index:(NSInteger *)index;
//把source的值(从ibegin开始到,长度为len)赋值到dest，dest从index开始赋值，index每赋一个byte会加1
-(void)MoveData:(Byte *)source ibegin:(NSInteger)ibegin len:(NSInteger) len   dest:(Byte *)dest dindex:(NSInteger *)dindex;

-(NSData *) ImportData:(nonnull  NSString*) data  encodingType:(EncodingType)encodingType;

-(void)Clear;

-(NSData *) GetHeaderCmd;
-(NSData *) GetTextCmd:(TextSetting *)textSetting text:(NSString *)text;
-(NSData *) GetCommonSetCmd:(CommonSetting *_Nonnull)commonset;
-(NSData *) GetBitMapCmd:(BitmapSetting *) bitmapSetting image:(UIImage *) image;
-(NSData *) GetQrCodeCmd;
-(NSData *) GetCmd;
-(NSData *) GetSelftestCmd;
-(NSData *) GetCRCmd;
-(NSData *) GetLFCmd;
-(NSData *) GetLFCRCmd;
-(NSData *)GetPrintEndCmd;


@end
