//
//  MainViewController.m
//  PrinterExample
//
//  Created by 朱正锋 on 08/12/2017.
//  Copyright © 2017 Printer. All rights reserved.
//

#import "MainViewController.h"
#import "PrinterManager.h"
#import "ProgressHUD.h"
#import "WifiInterface.h"
#import "PinCmdFactory.h"
#import "BleDeviceListController.h"


@interface MainViewController ()
{
   PrinterManager * _printerManager;
}
@end

@implementation MainViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    _Cboxinstruction.delegate = self;
    _CboxPortType.delegate = self;
    _Port = 9100;
    _Address = @"192.168.8.83";
    _printerManager = [PrinterManager sharedInstance];
    //_MainTableView.tableFooterView = [[UIView alloc] initWithFrame:CGRectMake(0,0,self.view.frame.size.width,10)];
    
    _MainTableView.separatorStyle = UITableViewCellSeparatorStyleNone;
    [_printerManager AddConnectObserver:self selector:@selector(handleNotification:)];
    
    
    //  [_MainTableView setCellLayoutMarginsFollowReadableWidth:<#(BOOL)#>]
    // Uncomment the following line to preserve selection between presentations.
    // self.clearsSelectionOnViewWillAppear = NO;
    
    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
    // self.navigationItem.rightBarButtonItem = self.editButtonItem;
}



-(void)UnregisterObserver{
  [[NSNotificationCenter defaultCenter] removeObserver:self];

}

-(void)dealloc {
    [self UnregisterObserver];
#if !__has_feature(objc_arc)
    [super dealloc];
#endif
}



- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}
#pragma handleNotification
- (void)handleNotification:(NSNotification *)notification{
    dispatch_async(dispatch_get_main_queue(),^{
        [ProgressHUD dismiss];
        
        NSLog(@"notification.object=%s",object_getClassName(notification.object));
        if([notification.name isEqualToString:(NSString *)PrinterConnectedNotification]||
        [notification.name isEqualToString:(NSString *)BleDeviceConnectedNotify])
        {
//            if ([notification.object isKindOfClass:[WifiInterface class]]) {
//                NSLog(@"object is WifiInterface");
//            }
//            
            [ProgressHUD showSuccess:@"printer connect success" Interaction:YES];
        
        }else if([notification.name isEqualToString:(NSString *)PrinterDisconnectedNotification] ||
                 [notification.name isEqualToString:(NSString *)BleDeviceDisconnectedNotify])
        
        {
            
            [ProgressHUD showSuccess:@"printer connect Disconnected" Interaction:YES];
            
        }
        [self refreshConnectState];
        
    });
}

-(void)refreshConnectState{
    if ([_printerManager.CurrentPrinter IsOpen]){
        self.navigationItem.title  = @"Printer is connected";
    } else
    {
        self.navigationItem.title  = @"Printer is Disconnected";
    }
}



#pragma mark - Table view data source



#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
     _printerManager.CurrentPrinterCmdType = (PrinterCmdType)_Cboxinstruction.currentIndex;
    
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}

- (BOOL)textField:(UITextField *)textField shouldChangeCharactersInRange:(NSRange)range replacementString:(NSString *)string {
    NSCharacterSet *charSet = [[NSCharacterSet characterSetWithCharactersInString:@"0123456789."] invertedSet];
    NSString *filteredStr = [[string componentsSeparatedByCharactersInSet:charSet] componentsJoinedByString:@""];
    if ([string isEqualToString:filteredStr]) {
        return YES;
    }
    return NO;
}



-(void) ConnectWifi{
    UIAlertController *alertController = [UIAlertController alertControllerWithTitle:@"Input Wifi Address" message:@"" preferredStyle:UIAlertControllerStyleAlert];
    [alertController addTextFieldWithConfigurationHandler:^(UITextField *textField){
        textField.placeholder = @"0.0.0.0";
        textField.text = _Address;
        textField.keyboardType = UIKeyboardTypeDecimalPad;
        textField.delegate = self;
        
    }];
    [alertController addTextFieldWithConfigurationHandler:^(UITextField *textField) {
        textField.placeholder = @"9100";
        textField.text =[NSString stringWithFormat:@"%ld",_Port];
        textField.secureTextEntry = false;
        textField.keyboardType = UIKeyboardTypeNumberPad;
        textField.delegate = self;

    }];
    
    UIAlertAction *cancelAction = [UIAlertAction actionWithTitle:@"Cancel" style:UIAlertActionStyleCancel handler:^(UIAlertAction *action){
        NSLog(@"Cancel");
        
    }];
    
    
    UIAlertAction *okAction = [UIAlertAction actionWithTitle:@"Ok" style:UIAlertActionStyleDefault handler:^(UIAlertAction * action){
         UITextField *addressField = alertController.textFields[0];;
        self.Address = addressField.text;
        UITextField * portField = alertController.textFields[1];
        self.Port = [portField.text integerValue];
        // NSLog(@"address=%@",_Address);
        [_printerManager DoConnectwifi: _printerManager.CurrentPrinterCmdType  Address:self.Address Port:self.Port];
     
        
    }];
    
    
    [alertController addAction:cancelAction];
    [alertController addAction:okAction];
    
    [self presentViewController:alertController animated:YES completion:nil];
    
}

-(void) ConnectBle{
    
    
    BleDeviceListController *controller = [[BleDeviceListController alloc] init];
    //controller.delegate = self;
    [[self navigationController] pushViewController:controller animated:YES];
}

-(void) ConnectMFI{
    
}

- (IBAction)btnConnect:(id)sender {
    switch (_CboxPortType.currentIndex) {
        case PrinterPortWifi:
            [self ConnectWifi];
            break;
        case PrinterPortBle:
            [self ConnectBle];
            break;
        case PrinterPortMFI:
            [self ConnectWifi];
            break;
        default:
            break;
    }
}
- (IBAction)btnDisConnect:(id)sender {
    [_printerManager.CurrentPrinter Close];
}

- (IBAction)btntest:(id)sender {
   // SLog(@"_printerManager.CurrentPrinter=%p",_printerManager.CurrentPrinter);
    if (_printerManager.CurrentPrinter.IsOpen){
        Cmd *cmd =  [_printerManager CreateCmdClass:(PrinterCmdType)_Cboxinstruction.currentIndex];
        if (cmd == NULL)
            return;
        [cmd Clear];
        [cmd Append:cmd.GetSelftestCmd];
        NSLog(@"data=%@",[cmd GetCmd]);
        if ([_printerManager.CurrentPrinter IsOpen]){
            [_printerManager.CurrentPrinter Write:[cmd GetCmd]];
        }
    
    }
}

- (IBAction)btnPrintText:(id)sender {
    Printer * currentprinter =_printerManager.CurrentPrinter;
    if (currentprinter.IsOpen){
        
        NSString* inputStr = @"this is a test中国人民";
        TextSetting *textst = [TextSetting new];
        [textst setIsBold:Set_DisEnable];
        [textst setIsTimes_Wide:Set_Enabled];
        [textst setIsTimes_Heigh:Set_Enabled];
       // [textst setIsTimes_Heigh:Set_Enabled];
        [textst setIsTimes4_Wide:Set_Enabled];
        [textst setAlignmode:Align_Left];
        [currentprinter setTextSets:textst];
        
       // Cmd *cmd = PinCmdFactory.Create;
        Cmd *cmd =  [_printerManager CreateCmdClass:(PrinterCmdType)_Cboxinstruction.currentIndex];
        [cmd Clear];
        [cmd Append:cmd.GetHeaderCmd];
        // [cmd Append:[(PinCmd*)cmd GetIsDualPrintCmd:true]];
        [cmd Append:[cmd GetTextCmd:currentprinter.TextSets text:inputStr]];
        [cmd Append:[cmd GetPrintEndCmd]];
        
        if ([currentprinter IsOpen]){
            [currentprinter Write:[cmd GetCmd]];
        }
        
        
   
        
    }
}


-(void)WBComboValueChanged:(id)sender{
    if (_printerManager.CurrentPrinter==nil || _printerManager.CurrentPrinterCmdType != _Cboxinstruction.currentIndex){
        _printerManager.CurrentPrinter = [_printerManager CreatePrinterClass:_Cboxinstruction.currentIndex];
    }
    
    
    if  ( _printerManager.CurrentPrinterCmdType != _Cboxinstruction.currentIndex ||
         _printerManager.CurrentPrinterPortType != _CboxPortType.currentIndex)
        [_printerManager.CurrentPrinter Close];
    _printerManager.CurrentPrinterCmdType = (PrinterCmdType)_Cboxinstruction.currentIndex;
    _printerManager.CurrentPrinterPortType = (PrinterPortType)_CboxPortType.currentIndex;
    
    if (_printerManager.CurrentPrinterPortType==PrinterPortBle){
       //  [[_printerManager.CurrentPrinter] startBle];
        
    }
}



@end
