//
//  BleDeviceListController.m
//  RTPrinter
//
//  Created by PRO on 15/12/20.
//  Copyright © 2015年 bluedrum. All rights reserved.
//

#import "BleDeviceListController.h"
#import "BlueToothFactory.h"


@interface BleDeviceListController(){
    BlueToothPI * _blueToothPI;
    
}
@end

@implementation BleDeviceListController


-(void)initPullRefresh{
    //采用iOS6 的自带的UIRefreshControl控制下拉刷新
    
    UIRefreshControl *refresh = [[UIRefreshControl alloc] init];
    refresh.tintColor = [UIColor lightGrayColor];
    refresh.attributedTitle = [[NSAttributedString alloc] initWithString:NSLocalizedString(@"scanning",nil)] ;
    [refresh addTarget:self action:@selector(refreshDevice:) forControlEvents:UIControlEventValueChanged];
    self.refreshControl = refresh;
    
    
    // self.isRefreshing = false;
    [self.refreshControl endRefreshing];
    
}

- (void)viewDidLoad {
    [super viewDidLoad];
    
    // Uncomment the following line to preserve selection between presentations.
    // self.clearsSelectionOnViewWillAppear = NO;
    
    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
    // self.navigationItem.rightBarButtonItem = self.editButtonItem;
//    _printerManager.printerInterface = nil;
//    if (_printerManager.printerInterface isKindOfClass:[BlueToothPI] )
//    
    _printerManager.printerInterface  = [BlueToothFactory Create:BlueToothKind_Ble];
    _blueToothPI = (BlueToothPI *)_printerManager.printerInterface;
    [_printerManager.CurrentPrinter setPrinterPi:_printerManager.printerInterface];
    [self registerBroadcast];
    
    [self performSelector:@selector(initPullRefresh) withObject:nil afterDelay:1.0f];

    
    
    //[self initPullRefresh];
    
 //   [self refreshDevice:self];
}

- (void)handleNotification:(NSNotification *)notification{
    
    if([notification.name isEqualToString:(NSString *)BleServiceStatusChanged ]){
        NSString * status = notification.object;
        
        switch([status intValue]){
            case BleScanComplete:
                [self.refreshControl endRefreshing];
                break;
        }
        [self.tableView reloadData];
    }
    else if([notification.name isEqualToString:(NSString *)BleServiceFindDevice ]){
        [self.tableView reloadData];
    }
    
    
}

-(void)registerBroadcast{
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(handleNotification:) name:(NSString *)BleServiceStatusChanged object:nil];
    
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(handleNotification:) name:(NSString *)BleServiceFindDevice object:nil];
    
    
    
}



-(IBAction)refreshDevice:(id)sender{
    [_blueToothPI startScan:3 isclear:YES];
    
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    
   //
    NSArray *devlist=_blueToothPI.getBleDevicelist;
    SLog(@"devlist=%p  count=%ld",devlist,[devlist count]);
    return [devlist count];
}
-(CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
    NSMutableArray *devlist = _blueToothPI.getBleDevicelist;
    if([devlist objectAtIndex:indexPath.row])
    {
        BleDevice *device=[devlist objectAtIndex:indexPath.row];
        if([device.address length]>0)
        {
            return 60;
        }
        return 40;
    }
    return 40.0f;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    NSString *CellIdentifier;
    
    
    
    CellIdentifier  = @"menu";
    
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    
    
    if (cell == nil) {
        
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:CellIdentifier];
    }
    NSMutableArray *devlist = _blueToothPI.getBleDevicelist;
    
    BleDevice * device =  [devlist objectAtIndex:indexPath.row];
     NSString * isConnect = [_blueToothPI isBind:device ]?@"(*)":@"";
    
       cell.textLabel.text =   [NSString stringWithFormat:@"%@%@ rssi:%ld",device.name, isConnect,device.rssiLevel] ;
    
    if([device.address length] == 0){
        cell.detailTextLabel.text = device.UUID;
    }
    else{
	
	//cell.detailTextLabel.text = [NSString stringWithFormat:@"%@\nAddress:<%@>",device.UUID,device.address];
        cell.detailTextLabel.text = device.address;
     
    }
    cell.detailTextLabel.numberOfLines = 0;
    
    return cell;

    
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    
    UITableViewCell *cell = [tableView cellForRowAtIndexPath:indexPath];
    NSMutableArray *devlist = _blueToothPI.getBleDevicelist;
    BleDevice * device =  [devlist objectAtIndex:indexPath.row];
    _blueToothPI.Address = device.UUID;
    [_blueToothPI stopScan];
    [_blueToothPI Close];
//    if([_blueToothPI isBind:device] ){
//       [_blueToothPI unbind:device];
//     }
    [_blueToothPI bind:device];
    [_blueToothPI Open];
    
    // [_delegate select:device];
    
    [self.navigationController popViewControllerAnimated:YES];
 
    
}

-(void)dealloc {
    [[NSNotificationCenter defaultCenter] removeObserver:self];
#if !__has_feature(objc_arc)
    [super dealloc];
#endif
}


@end
