//
//  TextViewController.m
//  PrinterExample
//
//  Created by King on 25/12/2017.
//  Copyright © 2017 Printer. All rights reserved.
//

#import "TextViewController.h"
#import "Printer.h"
#import "style.h"
#import "PrinterManager.h"
#import "LabelCommonSetting.h"
#import "ESCCmd.h"

@interface TextViewController ()

@end

@implementation TextViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
 /*
    _txtViewinput.layer.backgroundColor = [[UIColor clearColor] CGColor];
    
    _txtViewinput.layer.borderColor = [[UIColor colorWithRed:230.0/255.0 green:250.0/255.0 blue:250.0/255.0 alpha:1.0]CGColor];
    _txtViewinput.layer.borderWidth = 3.0;
    _txtViewinput.layer.cornerRadius = 8.0f;
    [_txtViewinput.layer setMasksToBounds:YES];
    */
    
    
    self.txtViewinput.layer.borderColor = FLAT_BLUE_COLOR.CGColor;
    self.txtViewinput.layer.borderWidth =1.0;
    self.txtViewinput.layer.cornerRadius =5.0;
    [self.txtViewinput.layer setMasksToBounds:YES];
    
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}




/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/


- (IBAction)btnPrintText:(id)sender {
    PrinterManager *_printerManager = PrinterManager.sharedInstance;
    Printer * currentprinter = _printerManager.CurrentPrinter;
    if (currentprinter.IsOpen){
        
        NSString* inputStr = self.txtViewinput.text;;
        TextSetting *textst = currentprinter.TextSets;
        [textst setIsBold:Set_Enabled];//ESC
        [textst setIsTimes_Wide:Set_DisEnable];//ESC,Pin
        [textst setIsTimes_Heigh:Set_DisEnable];//ESC,Pin
        [textst setIsTimes4_Wide:Set_DisEnable];//ESC,Pin
        [textst setIsTimes_Wide:Set_Enabled];//ESC,Pin
        [textst setAlignmode:Align_Left];//ESC
        [textst setIsUnderline:Set_Enabled];//ESC
        [textst setX_start:150];//TSC,Cpcl X coordinate of the upper left corner
        [textst setY_start:50];//TSC,Cpcl Y coordinate of the upper left corner
        [textst setX_multi:1];//TSC
        [textst setY_multi:1];//TSC
        [textst setTSCFonttype:TSCFontType_TSS24];//TSC
        [textst setRotate:Rotate0];//ESC:Rotate90,Rotate0 有效, TSC,CPcl:都有效

        
 
        Cmd *cmd =  [_printerManager CreateCmdClass:_printerManager.CurrentPrinterCmdType];
        [cmd Clear];
        [cmd setEncodingType:Encoding_GBK];
        NSData *headercmd = [_printerManager GetHeaderCmd:cmd cmdtype:_printerManager.CurrentPrinterCmdType];//
        [cmd Append:headercmd];
       
        if (_printerManager.CurrentPrinterCmdType==PrinterCmdPIN){
            // [cmd Append:[(PinCmd*)cmd GetIsDualPrintCmd:true]];
        }
        /*!
       
        NSArray * textArray = [inputStr componentsSeparatedByString:@"\n"];
        for(NSString * str in textArray ){
           NSData *data = [cmd GetTextCmd:currentprinter.TextSets text:str];
           textst.Y_start = textst.Y_start+30;
           [cmd Append:data];
           [cmd Append:cmd.GetLFCRCmd];
           data = nil;
        }
         */
        NSData *data = [cmd GetTextCmd:currentprinter.TextSets text:inputStr];
        [cmd Append:data];
        for (int i=0; i<3; i++) {
          [cmd Append:[cmd GetLFCRCmd]];
        }
   
     
        [cmd Append:[cmd GetCutPaperCmd:CutterMode_half]];//for ESC
        [cmd Append:[cmd GetBeepCmd:3 interval:10]];
        [cmd Append:[cmd GetOpenDrawerCmd:0 startTime:5 endTime:0]];
       
        
        [cmd Append:[cmd GetPrintEndCmd:1]];
        
        if ([currentprinter IsOpen]){
            SLog(@"data=%@",[cmd GetCmd]);
            [currentprinter Write:[cmd GetCmd]];
        }
        
        
        
        
    }
    
}




@end
